<?php

/**
 * This is a fake alternative virtual configuration that must be included before calling to
 * lib/setup.php in master configuration.
 *
 * The VMASTER host must point to a Moodle setup that holds the effective vmoodle block
 * holding the virtual configs. The basic configuration uses the same configuration
 * values as the original one (the configuration from config.php). Say, the physical
 * moodle is also the master of the virtual system.
 *
 * @package block-vmoodle
 * @category blocks
 * @author Moheissen Fabien (fabien.moheissen@gmail.com)
 * @license http://www.gnu.org/copyleft/gpl.html GNU GPL
 */

/**
* VMoodle configuration
* Must point to a VMaster server
*
* Please take case VMOODLE block needs two important patchs to be completely installed :
*
* Patch one : Adding XML-RPC support for blocks (mnet/xmlrpc/server.php)
* Patch two : Adding blocks subplugin discovery support (calling upgrade_subplugins generic function in blocklib.php)
* Information in the README file.
*
*/

require_once $CFG->dirroot."/blocks/vmoodle/bootlib.php";

// EDIT A CONFIGURATION FOR MASTER MOODLE //

$CFG->vmasterdbhost = 'localhost';
$CFG->vmasterdbtype = 'mysql';
$CFG->vmasterdbname = '';
$CFG->vmasterdblogin = '';
$CFG->vmasterdbpass = '';
$CFG->vmasterdbpersist =  false;
$CFG->vmasterprefix    = 'mdl_';
$CFG->vmoodledefault    = 1; // tells if the default physical config can be used as true host

vmoodle_get_hostname();

// TODO : insert customized additional code here if required


//

vmoodle_boot_configuration();

?>